import java.lang.*;
import java.io.*;
import java.util.concurrent.*;

public class Boss {

  public static void main(String[] args) {
    try {
      CountDownLatch prepSignal  = new CountDownLatch(6);
      CountDownLatch startSignal = new CountDownLatch(1);
      CountDownLatch endSignal   = new CountDownLatch(6);

      System.out.println("\nBOSS: PREPARE YOUR WORK\n");
      new Thread(new Worker("Herb",prepSignal,startSignal,endSignal)).start();
      new Thread(new Worker("Scott",prepSignal,startSignal,endSignal)).start();
      new Thread(new Worker("Bjarne",prepSignal,startSignal,endSignal)).start();
      new Thread(new Worker("Andrei",prepSignal,startSignal,endSignal)).start();
      new Thread(new Worker("Andrew",prepSignal,startSignal,endSignal)).start();
      new Thread(new Worker("David",prepSignal,startSignal,endSignal)).start();
      prepSignal.await();

      System.out.println("\nBOSS: START YOUR WORK\n");
      startSignal.countDown();

      endSignal.await();
      System.out.println("\nBOSS: GO HOME\n");
    } catch (Exception e) {
    }
  }
}

class Worker implements Runnable {
  private String iName;
  private CountDownLatch iPrepSignal, iStartSignal, iEndSignal;

  Worker(String pName, CountDownLatch pPrepSignal,
         CountDownLatch pStartSignal, CountDownLatch pEndSignal) {
    iName = pName;
    iPrepSignal  = pPrepSignal;
    iStartSignal = pStartSignal;
    iEndSignal   = pEndSignal;
  }

  public void run() {
    try {
     long prepareTime = 500 + (long) (1500*Math.random());
     Thread.currentThread().sleep(prepareTime);
     System.out.println(iName + " work prepared after " +
                         prepareTime + " milliseconds");			   
      iPrepSignal.countDown();
      iStartSignal.await();
      long workTime = 200 + (long) (200*Math.random());
      Thread.currentThread().sleep(workTime);	
      System.out.println(iName + " work done after " +
                         workTime + " milliseconds");			   
      iEndSignal.countDown();
    } catch (InterruptedException ex) {
    }
  }
}
